# UnoCSS Starter

Starterkit theme w/ UnoCSS and Vite preconfigured.

Additional information on generating themes can be found in the [Starterkit documentation](https://www.drupal.org/docs/core-modules-and-themes/core-themes/starterkit-theme).

# Theming

Start by installing the theme with composer.

TODO: Get generate starterkit working.

Copy theme to custom and rename files as a workaround to begin theming.

Customize uno.config.js. See https://unocss.dev/config/ and other documentation pages.

Configure vite dev server to work with your local development environment (TODO: Documentation).

Start theming with tailwind utilities in templates, and @apply statements in css.
See https://unocss.dev/integrations/postcss.

Start dev mode with npm run dev, experiment in index.html and style.css.

TODO: Better integration between index.html and drupal theme (templates, components, libraries, etc).
See https://github.com/larowlan/vite-plugin-twig-drupal

TODO: Organize libraries, provide initial files.

## Generate subtheme
```php core/scripts/drupal generate-theme --path=themes/custom --starterkit=unocss_starter --name="New Theme" --description="UnoCSS starter theme." new_theme```

# Build process

How this theme is built.

## Setup UnoCSS/Vite

1. Create a new starterkit theme.
  - php core/scripts/drupal generate-theme unocss_starter
2. Create vite project and install unocss.
  - npm create vite .
  - npm i -D unocss glob
3. Configure vite.
  - UnoCSS plugin.
  - Empty output dir, enable manifest.json.
  - Rollup input/output (see vite.config.js).
  - Enable vite in all libraries/components (see unocss_starter.info.yml).
  - [npm run build should now compile css]
4. Configure unocss.
  - presetUno.
  - Parse template classes.
  - Create unocss.js with import 'virtual:uno.css'.
  - Create unocss library w/ unocss.js, add as dependency to base.
  - [uno classes in templates now included in build]
5. Configure postcss.
   - See postcss.config.js.
   - [@apply in css should be transformed with uno]
6. Clean up vite files
  - Remove couter.js, javascript.svg.
  - Remove #app from index.html.
  - Clear out style.css.

## Libraries

Rearrange starterkit libraries.

Starterkit provides a collection of CSS files that are a mix of global base styles in the component layer, and component libraries that are included individually. See templates with {{ attach_library }}.

Create library directories and move files to clarify where new files belong.


1. Create libraries/base directory, containing base, layout, component, theme, state subdirectories.
2. Move base css files into libraries/base/component.
  - Check starterkit_theme.libraries.yml for which files are included in base vs separate libraries.
3. Create empty base.css, layout.css, component.css, theme.css and state.css files in libraries/base.
4. Import base component css in libraries/base.
  - @import each file in libraries/base/component.
  - Replace unocss_starter/base library css with base.css, layout.css, component.css, theme.css, and state.css in libraries.base.
5. Move components css into libraries/components.
  - Fix directory paths in unocss_starter.libraries.yml
6. Replace image directory path in css files.
7. Include base library css in main.js.
  - [Base styles now available in index.html]

## Known issues
- https://www.drupal.org/project/unocss_starter/issues/3481591