import UnoCSS from "unocss/vite";
import { defineConfig } from "vite";
import { globSync } from "glob";
import unoConfig from "./uno.config.js";
export default defineConfig(({ command, mode, isSsrBuild, isPreview }) => ({

  plugins: [
    UnoCSS(unoConfig)
  ],
  define: {
    'process.env': {
      VITE_IMAGE_BASE_URL: process.env.VITE_IMAGE_BASE_URL || '/themes/contrib/unocss_starter/demo/unocss_starter_demo/images'
    },
  },
  css: {
    devSourcemap: true
  },
  build: {
    emptyOutDir: true,
    manifest: true,
    rollupOptions: {
      input: [
        './unocss.js',
        ...globSync('libraries/*/*.css'),
        ...globSync('components/**/*.css')
      ],
      output: {
        entryFileNames: `[name].js`,
        assetFileNames: `[name].[ext]`
      }
    }
  },
  server: {
    cors: true,
    origin: 'https://SITE.ddev.site:5173'
  }
}))
