import UnoCSS from "unocss/vite";
import { defineConfig } from "vite";
import { globSync } from "glob";

export default defineConfig({
  plugins: [
    UnoCSS()
  ],
  build: {
    emptyOutDir: true,
    manifest: true,
    rollupOptions: {
      input: [
        'unocss.js',
        ...globSync('libraries/*/*.css')
      ],
      output: {
        entryFileNames: `[name].js`,
        assetFileNames: `[name].[ext]`
      }
    }
  },
  server: {
    cors: true,
    origin: 'https://SITE.ddev.site:5173'
  }
})
